# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.158
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class ComplianceRuleTemplate(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'id': 'ResourceId',
        'description': 'str',
        'properties': 'dict(str, ModelProperty)',
        'variations': 'list[ComplianceTemplateVariationDto]',
        'href': 'str',
        'version': 'Version',
        'links': 'list[Link]'
    }

    attribute_map = {
        'id': 'id',
        'description': 'description',
        'properties': 'properties',
        'variations': 'variations',
        'href': 'href',
        'version': 'version',
        'links': 'links'
    }

    required_map = {
        'id': 'optional',
        'description': 'optional',
        'properties': 'optional',
        'variations': 'optional',
        'href': 'optional',
        'version': 'optional',
        'links': 'optional'
    }

    def __init__(self, id=None, description=None, properties=None, variations=None, href=None, version=None, links=None, local_vars_configuration=None):  # noqa: E501
        """ComplianceRuleTemplate - a model defined in OpenAPI"
        
        :param id: 
        :type id: lusid.ResourceId
        :param description:  The description of the Compliance Template
        :type description: str
        :param properties:  Properties associated with the Compliance Template Variation
        :type properties: dict[str, lusid.ModelProperty]
        :param variations:  Variation details of a Compliance Template
        :type variations: list[lusid.ComplianceTemplateVariationDto]
        :param href:  The specific Uniform Resource Identifier (URI) for this resource at the requested asAt datetime.
        :type href: str
        :param version: 
        :type version: lusid.Version
        :param links:  Collection of links.
        :type links: list[lusid.Link]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._id = None
        self._description = None
        self._properties = None
        self._variations = None
        self._href = None
        self._version = None
        self._links = None
        self.discriminator = None

        if id is not None:
            self.id = id
        self.description = description
        self.properties = properties
        self.variations = variations
        self.href = href
        if version is not None:
            self.version = version
        self.links = links

    @property
    def id(self):
        """Gets the id of this ComplianceRuleTemplate.  # noqa: E501


        :return: The id of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: lusid.ResourceId
        """
        return self._id

    @id.setter
    def id(self, id):
        """Sets the id of this ComplianceRuleTemplate.


        :param id: The id of this ComplianceRuleTemplate.  # noqa: E501
        :type id: lusid.ResourceId
        """

        self._id = id

    @property
    def description(self):
        """Gets the description of this ComplianceRuleTemplate.  # noqa: E501

        The description of the Compliance Template  # noqa: E501

        :return: The description of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this ComplianceRuleTemplate.

        The description of the Compliance Template  # noqa: E501

        :param description: The description of this ComplianceRuleTemplate.  # noqa: E501
        :type description: str
        """
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 1024):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and not re.search(r'^[\s\S]*$', description)):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._description = description

    @property
    def properties(self):
        """Gets the properties of this ComplianceRuleTemplate.  # noqa: E501

        Properties associated with the Compliance Template Variation  # noqa: E501

        :return: The properties of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: dict[str, lusid.ModelProperty]
        """
        return self._properties

    @properties.setter
    def properties(self, properties):
        """Sets the properties of this ComplianceRuleTemplate.

        Properties associated with the Compliance Template Variation  # noqa: E501

        :param properties: The properties of this ComplianceRuleTemplate.  # noqa: E501
        :type properties: dict[str, lusid.ModelProperty]
        """

        self._properties = properties

    @property
    def variations(self):
        """Gets the variations of this ComplianceRuleTemplate.  # noqa: E501

        Variation details of a Compliance Template  # noqa: E501

        :return: The variations of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: list[lusid.ComplianceTemplateVariationDto]
        """
        return self._variations

    @variations.setter
    def variations(self, variations):
        """Sets the variations of this ComplianceRuleTemplate.

        Variation details of a Compliance Template  # noqa: E501

        :param variations: The variations of this ComplianceRuleTemplate.  # noqa: E501
        :type variations: list[lusid.ComplianceTemplateVariationDto]
        """

        self._variations = variations

    @property
    def href(self):
        """Gets the href of this ComplianceRuleTemplate.  # noqa: E501

        The specific Uniform Resource Identifier (URI) for this resource at the requested asAt datetime.  # noqa: E501

        :return: The href of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this ComplianceRuleTemplate.

        The specific Uniform Resource Identifier (URI) for this resource at the requested asAt datetime.  # noqa: E501

        :param href: The href of this ComplianceRuleTemplate.  # noqa: E501
        :type href: str
        """

        self._href = href

    @property
    def version(self):
        """Gets the version of this ComplianceRuleTemplate.  # noqa: E501


        :return: The version of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: lusid.Version
        """
        return self._version

    @version.setter
    def version(self, version):
        """Sets the version of this ComplianceRuleTemplate.


        :param version: The version of this ComplianceRuleTemplate.  # noqa: E501
        :type version: lusid.Version
        """

        self._version = version

    @property
    def links(self):
        """Gets the links of this ComplianceRuleTemplate.  # noqa: E501

        Collection of links.  # noqa: E501

        :return: The links of this ComplianceRuleTemplate.  # noqa: E501
        :rtype: list[lusid.Link]
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this ComplianceRuleTemplate.

        Collection of links.  # noqa: E501

        :param links: The links of this ComplianceRuleTemplate.  # noqa: E501
        :type links: list[lusid.Link]
        """

        self._links = links

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, ComplianceRuleTemplate):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, ComplianceRuleTemplate):
            return True

        return self.to_dict() != other.to_dict()
