# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.158
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class OrderGraphBlockOrderSynopsis(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'quantity': 'float',
        'quantity_by_state': 'dict(str, float)',
        'details': 'list[OrderGraphBlockOrderDetail]'
    }

    attribute_map = {
        'quantity': 'quantity',
        'quantity_by_state': 'quantityByState',
        'details': 'details'
    }

    required_map = {
        'quantity': 'required',
        'quantity_by_state': 'optional',
        'details': 'required'
    }

    def __init__(self, quantity=None, quantity_by_state=None, details=None, local_vars_configuration=None):  # noqa: E501
        """OrderGraphBlockOrderSynopsis - a model defined in OpenAPI"
        
        :param quantity:  Total number of units ordered. (required)
        :type quantity: float
        :param quantity_by_state:  Total number of units placed.
        :type quantity_by_state: dict(str, float)
        :param details:  Identifiers and other info for each order in this block. (required)
        :type details: list[lusid.OrderGraphBlockOrderDetail]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._quantity = None
        self._quantity_by_state = None
        self._details = None
        self.discriminator = None

        self.quantity = quantity
        self.quantity_by_state = quantity_by_state
        self.details = details

    @property
    def quantity(self):
        """Gets the quantity of this OrderGraphBlockOrderSynopsis.  # noqa: E501

        Total number of units ordered.  # noqa: E501

        :return: The quantity of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :rtype: float
        """
        return self._quantity

    @quantity.setter
    def quantity(self, quantity):
        """Sets the quantity of this OrderGraphBlockOrderSynopsis.

        Total number of units ordered.  # noqa: E501

        :param quantity: The quantity of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :type quantity: float
        """
        if self.local_vars_configuration.client_side_validation and quantity is None:  # noqa: E501
            raise ValueError("Invalid value for `quantity`, must not be `None`")  # noqa: E501

        self._quantity = quantity

    @property
    def quantity_by_state(self):
        """Gets the quantity_by_state of this OrderGraphBlockOrderSynopsis.  # noqa: E501

        Total number of units placed.  # noqa: E501

        :return: The quantity_by_state of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :rtype: dict(str, float)
        """
        return self._quantity_by_state

    @quantity_by_state.setter
    def quantity_by_state(self, quantity_by_state):
        """Sets the quantity_by_state of this OrderGraphBlockOrderSynopsis.

        Total number of units placed.  # noqa: E501

        :param quantity_by_state: The quantity_by_state of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :type quantity_by_state: dict(str, float)
        """

        self._quantity_by_state = quantity_by_state

    @property
    def details(self):
        """Gets the details of this OrderGraphBlockOrderSynopsis.  # noqa: E501

        Identifiers and other info for each order in this block.  # noqa: E501

        :return: The details of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :rtype: list[lusid.OrderGraphBlockOrderDetail]
        """
        return self._details

    @details.setter
    def details(self, details):
        """Sets the details of this OrderGraphBlockOrderSynopsis.

        Identifiers and other info for each order in this block.  # noqa: E501

        :param details: The details of this OrderGraphBlockOrderSynopsis.  # noqa: E501
        :type details: list[lusid.OrderGraphBlockOrderDetail]
        """
        if self.local_vars_configuration.client_side_validation and details is None:  # noqa: E501
            raise ValueError("Invalid value for `details`, must not be `None`")  # noqa: E501

        self._details = details

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderGraphBlockOrderSynopsis):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, OrderGraphBlockOrderSynopsis):
            return True

        return self.to_dict() != other.to_dict()
