# coding: utf-8

"""
    LUSID API

    FINBOURNE Technology  # noqa: E501

    The version of the OpenAPI document: 1.1.158
    Contact: info@finbourne.com
    Generated by: https://openapi-generator.tech
"""


try:
    from inspect import getfullargspec
except ImportError:
    from inspect import getargspec as getfullargspec
import pprint
import re  # noqa: F401
import six

from lusid.configuration import Configuration


class UpdateComplianceTemplateRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
      required_map (dict): The key is attribute name
                           and the value is whether it is 'required' or 'optional'.
    """
    openapi_types = {
        'code': 'str',
        'description': 'str',
        'variations': 'list[ComplianceTemplateVariationRequest]'
    }

    attribute_map = {
        'code': 'code',
        'description': 'description',
        'variations': 'variations'
    }

    required_map = {
        'code': 'required',
        'description': 'required',
        'variations': 'required'
    }

    def __init__(self, code=None, description=None, variations=None, local_vars_configuration=None):  # noqa: E501
        """UpdateComplianceTemplateRequest - a model defined in OpenAPI"
        
        :param code:  The code given for the Compliance Template (required)
        :type code: str
        :param description:  The description of the Compliance Template (required)
        :type description: str
        :param variations:  Variation details of a Compliance Template (required)
        :type variations: list[lusid.ComplianceTemplateVariationRequest]

        """  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration.get_default_copy()
        self.local_vars_configuration = local_vars_configuration

        self._code = None
        self._description = None
        self._variations = None
        self.discriminator = None

        self.code = code
        self.description = description
        self.variations = variations

    @property
    def code(self):
        """Gets the code of this UpdateComplianceTemplateRequest.  # noqa: E501

        The code given for the Compliance Template  # noqa: E501

        :return: The code of this UpdateComplianceTemplateRequest.  # noqa: E501
        :rtype: str
        """
        return self._code

    @code.setter
    def code(self, code):
        """Sets the code of this UpdateComplianceTemplateRequest.

        The code given for the Compliance Template  # noqa: E501

        :param code: The code of this UpdateComplianceTemplateRequest.  # noqa: E501
        :type code: str
        """
        if self.local_vars_configuration.client_side_validation and code is None:  # noqa: E501
            raise ValueError("Invalid value for `code`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and len(code) > 64):
            raise ValueError("Invalid value for `code`, length must be less than or equal to `64`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and len(code) < 1):
            raise ValueError("Invalid value for `code`, length must be greater than or equal to `1`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                code is not None and not re.search(r'^[a-zA-Z0-9\-_]+$', code)):  # noqa: E501
            raise ValueError(r"Invalid value for `code`, must be a follow pattern or equal to `/^[a-zA-Z0-9\-_]+$/`")  # noqa: E501

        self._code = code

    @property
    def description(self):
        """Gets the description of this UpdateComplianceTemplateRequest.  # noqa: E501

        The description of the Compliance Template  # noqa: E501

        :return: The description of this UpdateComplianceTemplateRequest.  # noqa: E501
        :rtype: str
        """
        return self._description

    @description.setter
    def description(self, description):
        """Sets the description of this UpdateComplianceTemplateRequest.

        The description of the Compliance Template  # noqa: E501

        :param description: The description of this UpdateComplianceTemplateRequest.  # noqa: E501
        :type description: str
        """
        if self.local_vars_configuration.client_side_validation and description is None:  # noqa: E501
            raise ValueError("Invalid value for `description`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) > 1024):
            raise ValueError("Invalid value for `description`, length must be less than or equal to `1024`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and len(description) < 0):
            raise ValueError("Invalid value for `description`, length must be greater than or equal to `0`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                description is not None and not re.search(r'^[\s\S]*$', description)):  # noqa: E501
            raise ValueError(r"Invalid value for `description`, must be a follow pattern or equal to `/^[\s\S]*$/`")  # noqa: E501

        self._description = description

    @property
    def variations(self):
        """Gets the variations of this UpdateComplianceTemplateRequest.  # noqa: E501

        Variation details of a Compliance Template  # noqa: E501

        :return: The variations of this UpdateComplianceTemplateRequest.  # noqa: E501
        :rtype: list[lusid.ComplianceTemplateVariationRequest]
        """
        return self._variations

    @variations.setter
    def variations(self, variations):
        """Sets the variations of this UpdateComplianceTemplateRequest.

        Variation details of a Compliance Template  # noqa: E501

        :param variations: The variations of this UpdateComplianceTemplateRequest.  # noqa: E501
        :type variations: list[lusid.ComplianceTemplateVariationRequest]
        """
        if self.local_vars_configuration.client_side_validation and variations is None:  # noqa: E501
            raise ValueError("Invalid value for `variations`, must not be `None`")  # noqa: E501

        self._variations = variations

    def to_dict(self, serialize=False):
        """Returns the model properties as a dict"""
        result = {}

        def convert(x):
            if hasattr(x, "to_dict"):
                args = getfullargspec(x.to_dict).args
                if len(args) == 1:
                    return x.to_dict()
                else:
                    return x.to_dict(serialize)
            else:
                return x

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            attr = self.attribute_map.get(attr, attr) if serialize else attr
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: convert(x),
                    value
                ))
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], convert(item[1])),
                    value.items()
                ))
            else:
                result[attr] = convert(value)

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, UpdateComplianceTemplateRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, UpdateComplianceTemplateRequest):
            return True

        return self.to_dict() != other.to_dict()
